/*
Continuous Testing Toolkit
Copyright (C) 2009 Paul R. Holser, Jr.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

package org.infinitest.toolkit.runners;

import java.lang.annotation.Annotation;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.junit.runners.model.FrameworkMethod;
import org.junit.runners.model.Statement;
import org.junit.runners.model.TestClass;

abstract class RunEnclosingAndEnclosedFrameworkMethod extends Statement {
    protected final Statement next;

    protected final Map<Object, List<FrameworkMethod>> targetsToMethods =
        new LinkedHashMap<Object, List<FrameworkMethod>>();

    protected RunEnclosingAndEnclosedFrameworkMethod(Statement next) {
        this.next = next;
    }

    final void add(Object target, TestClass testClass) {
        targetsToMethods.put(target, testClass.getAnnotatedMethods(frameworkMethodAnnotationClass()));
    }

    protected abstract Class<? extends Annotation> frameworkMethodAnnotationClass();
}
